#include <bits/stdc++.h>

#define FOR(i,a,b) for (int i = (a); i <= (b); i++)
#define FORD(i,a,b) for (int i = (a); i >= (b); i--)
#define REP(i,b) for (int i = 0; i < (b); i++)

using namespace std;

typedef long long ll;

int n,k;
vector<ll> sous[205];
bool visited[205];
ll dp[205][205][3];
ll ndp[205][205][3];

const ll md = 1000000007;

void madd(ll &num, ll x) {
	num = (num + x) % md;
}

void dfs(int v) {
	assert(!visited[v]);
	visited[v] = true;
	FOR(i, 0, k) dp[v][i][0] = dp[v][i][1] = dp[v][i][2] = 0;
	dp[v][0][0] = 1;
	dp[v][1][1] = 1;
	printf("# dfs %d\n", v);
	for (int s : sous[v]) {
		if (visited[s]) continue;
		dfs(s);
		FOR(i, 0, k) REP(t, 3) ndp[v][i][t] = dp[v][i][t];
		FOR(i, 0, k) {
			madd(ndp[v][i][0], dp[s][i][0] + dp[s][i][2]);
			FOR(j, 1, i) madd(ndp[v][i][0], dp[v][j][0] * (dp[s][i-j][0] + dp[s][i-j][2]));
		}
		FOR(i, 0, k) {
			madd(ndp[v][i][1], dp[s][i-1][0]);
			FOR(j, 1, i-1) madd(ndp[v][i][1], dp[v][j][1] * dp[s][i-j-1][0]);
		}
		FOR(i, 0, k) {
			madd(ndp[v][i][2], dp[s][i-1][1] + dp[s][i-1][2]);
			FOR(j, 0, i-1) madd(ndp[v][i][2], dp[v][j][2] * (dp[s][i-j-1][1] + dp[s][i-j-1][2]));
		}
		FOR(i, 0, k) REP(t, 3) dp[v][i][t] = ndp[v][i][t];
	}
	FOR(i, 0, k) printf("# dp[%d][%d] = { %lld, %lld, %lld }\n", v, i, dp[v][i][0], dp[v][i][1], dp[v][i][2]);
	printf("# end dfs %d\n", v);
}

int main() {
	while (scanf("%d", &n) == 1) {
		REP(i, n) sous[i].clear();
		REP(i, n) visited[i] = false;
		scanf("%d", &k);
		REP(i,n-1) {
			int a, b;
			scanf("%d%d", &a, &b);
			a--;
			b--;
			sous[a].push_back(b);
			sous[b].push_back(a);
		}
		dfs(0);
		printf("%lld\n", (dp[0][k][0] + dp[0][k][2]) % md);
	}
	return 0;
}

